Index: trunk/src/org/openstreetmap/josm/gui/io/UploadAndSaveProgressRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/UploadAndSaveProgressRenderer.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/UploadAndSaveProgressRenderer.java	(revision 2025)
@@ -0,0 +1,92 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import java.awt.GridBagConstraints;
+import java.awt.GridBagLayout;
+import java.awt.Insets;
+import java.beans.PropertyChangeEvent;
+import java.beans.PropertyChangeListener;
+
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+import javax.swing.JProgressBar;
+
+import org.openstreetmap.josm.gui.io.SaveLayersModel.Mode;
+import org.openstreetmap.josm.gui.progress.ProgressRenderer;
+
+class UploadAndSaveProgressRenderer extends JPanel implements ProgressRenderer, PropertyChangeListener {
+
+    private JLabel lblTaskTitle;
+    private JLabel lblCustomText;
+    private JProgressBar progressBar;
+
+    protected void build() {
+        setLayout(new GridBagLayout());
+        GridBagConstraints gc = new GridBagConstraints();
+        gc.gridx = 0;
+        gc.gridy = 0;
+        gc.fill = GridBagConstraints.HORIZONTAL;
+        gc.weightx = 1.0;
+        gc.weighty = 0.0;
+        gc.insets = new Insets(5,0,0,5);
+        add(lblTaskTitle = new JLabel(""), gc);
+
+        gc.gridx = 0;
+        gc.gridy = 1;
+        gc.fill = GridBagConstraints.HORIZONTAL;
+        gc.weightx = 1.0;
+        gc.weighty = 0.0;
+        gc.insets = new Insets(5,0,0,5);
+        add(lblCustomText = new JLabel(""), gc);
+
+        gc.gridx = 0;
+        gc.gridy = 2;
+        gc.fill = GridBagConstraints.HORIZONTAL;
+        gc.weightx = 1.0;
+        gc.weighty = 0.0;
+        gc.insets = new Insets(5,0,0,5);
+        add(progressBar = new JProgressBar(JProgressBar.HORIZONTAL), gc);
+    }
+
+    public UploadAndSaveProgressRenderer() {
+        build();
+        // initially not visible
+        setVisible(false);
+    }
+
+    public void setCustomText(String message) {
+        lblCustomText.setText(message);
+        repaint();
+    }
+
+    public void setIndeterminate(boolean indeterminate) {
+        progressBar.setIndeterminate(indeterminate);
+        repaint();
+    }
+
+    public void setMaximum(int maximum) {
+        progressBar.setMaximum(maximum);
+        repaint();
+    }
+
+    public void setTaskTitle(String taskTitle) {
+        lblTaskTitle.setText(taskTitle);
+        repaint();
+    }
+
+    public void setValue(int value) {
+        progressBar.setValue(value);
+        repaint();
+    }
+
+    public void propertyChange(PropertyChangeEvent evt) {
+        if (evt.getPropertyName().equals(SaveLayersModel.MODE_PROP)) {
+            Mode mode = (Mode)evt.getNewValue();
+            switch(mode) {
+                case EDITING_DATA: setVisible(false); break;
+                case UPLOADING_AND_SAVING: setVisible(true); break;
+            }
+        }
+        getParent().validate();
+    }
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/UploadLayerTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/UploadLayerTask.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/UploadLayerTask.java	(revision 2025)
@@ -0,0 +1,88 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+import java.util.Collection;
+
+import org.openstreetmap.josm.data.APIDataSet;
+import org.openstreetmap.josm.data.osm.DataSet;
+import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.openstreetmap.josm.gui.layer.OsmDataLayer;
+import org.openstreetmap.josm.gui.progress.NullProgressMonitor;
+import org.openstreetmap.josm.gui.progress.ProgressMonitor;
+import org.openstreetmap.josm.io.OsmServerWriter;
+
+/**
+ * UploadLayerTask uploads the data managed by an {@see OsmDataLayer} asynchronously.
+ * 
+ * <pre>
+ *     ExecutorService executorService = ...
+ *     UploadLayerTask task = new UploadLayerTask(layer, monitor);
+ *     Future<?> taskFuture = executorServce.submit(task)
+ *     try {
+ *        // wait for the task to complete
+ *        taskFuture.get();
+ *     } catch(Exception e) {
+ *        e.printStackTracek();
+ *     }
+ * </pre>
+ */
+class UploadLayerTask extends AbstractIOTask implements Runnable {
+    private OsmServerWriter writer;
+    private OsmDataLayer layer;
+    private ProgressMonitor monitor;
+
+    /**
+     * 
+     * @param layer the layer. Must not be null.
+     * @param monitor  a progress monitor. If monitor is null, uses {@see NullProgressMonitor#INSTANCE}
+     * @throws IllegalArgumentException thrown, if layer is null
+     */
+    public UploadLayerTask(OsmDataLayer layer, ProgressMonitor monitor) {
+        if (layer == null)
+            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", layer));
+        if (monitor == null) {
+            monitor = NullProgressMonitor.INSTANCE;
+        }
+        this.layer = layer;
+        this.monitor = monitor;
+    }
+
+    @Override
+    public void run() {
+        monitor.subTask(tr("Preparing primitives to upload ..."));
+        Collection<OsmPrimitive> toUpload = new APIDataSet(layer.data).getPrimitives();
+        if (toUpload.isEmpty())
+            return;
+        writer = new OsmServerWriter();
+        try {
+            ProgressMonitor m = monitor.createSubTaskMonitor(ProgressMonitor.ALL_TICKS, false);
+            if (isCancelled()) return;
+            writer.uploadOsm(layer.data.version, toUpload, m);
+        } catch (Exception sxe) {
+            if (isCancelled()) {
+                System.out.println("Ignoring exception caught because upload is cancelled. Exception is: " + sxe.toString());
+                return;
+            }
+            setLastException(sxe);
+        }
+
+        if (isCancelled())
+            return;
+        layer.cleanupAfterUpload(writer.getProcessedPrimitives());
+        DataSet.fireSelectionChanged(layer.data.getSelected());
+        layer.fireDataChange();
+        layer.onPostUploadToServer();
+    }
+
+    @Override
+    public void cancel() {
+        // make sure the the softCancel operation is serialized with
+        // blocks which can be interrupted.
+        setCancelled(true);
+        if (writer != null) {
+            writer.disconnectActiveConnection();
+        }
+    }
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/UploadOrSaveState.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/UploadOrSaveState.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/UploadOrSaveState.java	(revision 2025)
@@ -0,0 +1,17 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+public enum UploadOrSaveState {
+    /**
+     * a data layer was successfully saved or upload to the server
+     */
+    OK,
+    /**
+     * uploading or saving a data layer has failed
+     */
+    FAILED,
+    /**
+     * uploading or saving a data layer was cancelled
+     */
+    CANCELLED
+}
Index: trunk/src/org/openstreetmap/josm/gui/layer/GpxLayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/GpxLayer.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/layer/GpxLayer.java	(revision 2025)
@@ -895,5 +895,5 @@
                 }
             }
-            new DownloadOsmTaskList().download(false, toDownload, new PleaseWaitProgressMonitor());
+            new DownloadOsmTaskList().download(false, toDownload, new PleaseWaitProgressMonitor(tr("Download data")));
         }
     }
Index: trunk/src/org/openstreetmap/josm/gui/layer/Layer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/Layer.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/layer/Layer.java	(revision 2025)
@@ -45,5 +45,5 @@
 
     /** keeps track of property change listeners */
-    private PropertyChangeSupport propertyChangeSupport;
+    protected PropertyChangeSupport propertyChangeSupport;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/layer/OsmDataLayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/OsmDataLayer.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/layer/OsmDataLayer.java	(revision 2025)
@@ -71,4 +71,25 @@
  */
 public class OsmDataLayer extends Layer {
+    static public final String REQUIRES_SAVE_TO_DISK_PROP = OsmDataLayer.class.getName() + ".requiresSaveToDisk";
+    static public final String REQUIRES_UPLOAD_TO_SERVER_PROP = OsmDataLayer.class.getName() + ".requiresUploadToServer";
+
+    private boolean requiresSaveToFile = false;
+    private boolean requiresUploadToServer = false;
+
+    protected void setRequiresSaveToFile(boolean newValue) {
+        boolean oldValue = requiresSaveToFile;
+        requiresSaveToFile = newValue;
+        if (oldValue != newValue) {
+            propertyChangeSupport.firePropertyChange(REQUIRES_SAVE_TO_DISK_PROP, oldValue, newValue);
+        }
+    }
+
+    protected void setRequiresUploadToServer(boolean newValue) {
+        boolean oldValue = requiresUploadToServer;
+        requiresUploadToServer = newValue;
+        if (oldValue != newValue) {
+            propertyChangeSupport.firePropertyChange(REQUIRES_UPLOAD_TO_SERVER_PROP, oldValue, newValue);
+        }
+    }
 
     /** the global counter for created data layers */
@@ -96,5 +117,5 @@
         private void inc(final OsmPrimitive osm, final int i) {
             normal[i]++;
-            if (osm.deleted) {
+            if (osm.isDeleted()) {
                 deleted[i]++;
             }
@@ -113,7 +134,4 @@
     }
 
-    public interface ModifiedChangedListener {
-        void modifiedChanged(boolean value, OsmDataLayer source);
-    }
     public interface CommandQueueListener {
         void commandChanged(int queueSize, int redoSize);
@@ -130,14 +148,4 @@
     private ConflictCollection conflicts;
 
-    /**
-     * Whether the data of this layer was modified during the session.
-     */
-    private boolean modified = false;
-    /**
-     * Whether the data was modified due an upload of the data to the server.
-     */
-    public boolean uploadedModified = false;
-
-    public final LinkedList<ModifiedChangedListener> listenerModified = new LinkedList<ModifiedChangedListener>();
     public final LinkedList<DataChangeListener> listenerDataChanged = new LinkedList<DataChangeListener>();
 
@@ -310,16 +318,7 @@
     @Override public void visitBoundingBox(final BoundingXYVisitor v) {
         for (final Node n : data.nodes)
-            if (!n.deleted && !n.incomplete) {
+            if (!n.isDeleted() && !n.incomplete) {
                 v.visit(n);
             }
-    }
-
-    /**
-     * Cleanup the layer after save to disk. Just marks the layer as unmodified.
-     * Leaves the undo/redo stack unchanged.
-     *
-     */
-    public void cleanupAfterSaveToDisk() {
-        setModified(false);
     }
 
@@ -333,5 +332,4 @@
      */
     public void cleanupAfterUpload(final Collection<OsmPrimitive> processed) {
-
         // return immediately if an upload attempt failed
         if (processed == null || processed.isEmpty())
@@ -351,6 +349,4 @@
             cleanIterator(it, processedSet);
         }
-
-        setModified(true);
     }
 
@@ -367,20 +363,7 @@
         if (!processed.remove(osm))
             return;
-        osm.modified = false;
-        if (osm.deleted) {
+        osm.setModified(false);
+        if (osm.isDeleted()) {
             it.remove();
-        }
-    }
-
-    public boolean isModified() {
-        return modified;
-    }
-
-    public void setModified(final boolean modified) {
-        if (modified == this.modified)
-            return;
-        this.modified = modified;
-        for (final ModifiedChangedListener l : listenerModified) {
-            l.modifiedChanged(modified, this);
         }
     }
@@ -392,5 +375,5 @@
         int size = 0;
         for (final OsmPrimitive osm : list)
-            if (!osm.deleted) {
+            if (!osm.isDeleted()) {
                 size++;
             }
@@ -446,4 +429,6 @@
 
     public void fireDataChange() {
+        setRequiresSaveToFile(true);
+        setRequiresUploadToServer(true);
         for (DataChangeListener dcl : listenerDataChanged) {
             dcl.dataChanged(this);
@@ -456,5 +441,5 @@
         HashSet<Node> doneNodes = new HashSet<Node>();
         for (Way w : data.ways) {
-            if (w.incomplete || w.deleted) {
+            if (w.incomplete || w.isDeleted()) {
                 continue;
             }
@@ -468,5 +453,5 @@
             ArrayList<WayPoint> trkseg = null;
             for (Node n : w.getNodes()) {
-                if (n.incomplete || n.deleted) {
+                if (n.incomplete || n.isDeleted()) {
                     trkseg = null;
                     continue;
@@ -492,5 +477,5 @@
         // records them?
         for (Node n : data.nodes) {
-            if (n.incomplete || n.deleted || doneNodes.contains(n)) {
+            if (n.incomplete || n.isDeleted() || doneNodes.contains(n)) {
                 continue;
             }
@@ -546,3 +531,55 @@
         return conflicts;
     }
+
+    /**
+     * Replies true if the data managed by this layer needs to be uploaded to
+     * the server because it contains at least one modified primitive.
+     * 
+     * @return true if the data managed by this layer needs to be uploaded to
+     * the server because it contains at least one modified primitive; false,
+     * otherwise
+     */
+    public boolean requiresUploadToServer() {
+        return requiresUploadToServer;
+    }
+
+    /**
+     * Replies true if the data managed by this layer needs to be saved to
+     * a file. Only replies true if a file is assigned to this layer and
+     * if the data managed by this layer has been modified since the last
+     * save operation to the file.
+     * 
+     * @return true if the data managed by this layer needs to be saved to
+     * a file
+     */
+    public boolean requiresSaveToFile() {
+        return getAssociatedFile() != null && requiresSaveToFile;
+    }
+
+    /**
+     * Initializes the layer after a successful load of OSM data from a file
+     * 
+     */
+    public void onPostLoadFromFile() {
+        setRequiresSaveToFile(false);
+        setRequiresUploadToServer(data.isModified());
+    }
+
+    /**
+     * Initializes the layer after a successful save of OSM data to a file
+     * 
+     */
+    public void onPostSaveToFile() {
+        setRequiresSaveToFile(false);
+        setRequiresUploadToServer(data.isModified());
+    }
+
+    /**
+     * Initializes the layer after a successful upload to the server
+     * 
+     */
+    public void onPostUploadToServer() {
+        setRequiresUploadToServer(false);
+        // keep requiresSaveToDisk unchanged
+    }
 }
Index: trunk/src/org/openstreetmap/josm/gui/progress/PleaseWaitProgressMonitor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/progress/PleaseWaitProgressMonitor.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/progress/PleaseWaitProgressMonitor.java	(revision 2025)
@@ -28,7 +28,9 @@
 
     private PleaseWaitDialog dialog;
+    private String windowTitle;
 
-    public PleaseWaitProgressMonitor() {
+    public PleaseWaitProgressMonitor(String windowTitle) {
         this(JOptionPane.getFrameForComponent(Main.map));
+        this.windowTitle = windowTitle;
     }
 
@@ -86,4 +88,7 @@
                     throw new ProgressException("PleaseWaitDialog parent must be either Frame or Dialog");
 
+                if (windowTitle != null) {
+                    dialog.setTitle(windowTitle);
+                }
                 dialog.cancel.setEnabled(true);
                 dialog.setCustomText("");
Index: trunk/src/org/openstreetmap/josm/gui/progress/ProgressRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/progress/ProgressRenderer.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/progress/ProgressRenderer.java	(revision 2025)
@@ -0,0 +1,15 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.progress;
+
+/**
+ * Swing components can implement this interface and use a {@see SwingRenderingProgressMonitor}
+ * to render progress information.
+ * 
+ */
+public interface ProgressRenderer {
+    void setTaskTitle(String taskTitle);
+    void setCustomText(String message);
+    void setIndeterminate(boolean indeterminate);
+    void setMaximum(int maximum);
+    void setValue(int value);
+}
Index: trunk/src/org/openstreetmap/josm/gui/progress/SwingRenderingProgressMonitor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/progress/SwingRenderingProgressMonitor.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/progress/SwingRenderingProgressMonitor.java	(revision 2025)
@@ -0,0 +1,100 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.progress;
+
+import javax.swing.SwingUtilities;
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+/**
+ * SwingRenderingProgressMonitor is progress monitor which delegates the rendering
+ * of progress information to a {@see ProgressRenderer}.
+ * Methods of the progress renderer are always called on the Swing EDT.
+ *
+ */
+public class SwingRenderingProgressMonitor extends AbstractProgressMonitor {
+    private static final int PROGRESS_BAR_MAX = 100;
+    private int currentProgressValue = 0;
+    private ProgressRenderer delegate;
+
+    /**
+     * 
+     * @param delegate the delegate which renders the progress information. Must not be null.
+     * @throws IllegalArgumentException thrown if delegate is null
+     * 
+     */
+    public SwingRenderingProgressMonitor(ProgressRenderer delegate) {
+        super(new CancelHandler());
+        if (delegate == null)
+            throw new IllegalArgumentException(tr("parameter ''{0}'' must not be null", "delegate"));
+        this.delegate = delegate;
+    }
+
+    private void doInEDT(Runnable runnable) {
+        if (SwingUtilities.isEventDispatchThread()) {
+            runnable.run();
+        } else {
+            SwingUtilities.invokeLater(runnable);
+        }
+    }
+
+    @Override
+    public void doBeginTask() {
+        doInEDT(new Runnable() {
+            public void run() {
+                delegate.setCustomText("");
+                delegate.setMaximum(PROGRESS_BAR_MAX);
+            }
+        });
+    }
+
+    @Override
+    public void doFinishTask() {
+        // do nothing
+    }
+
+    @Override
+    protected void updateProgress(double progressValue) {
+        final int newValue = (int)(progressValue * PROGRESS_BAR_MAX);
+        if (newValue != currentProgressValue) {
+            currentProgressValue = newValue;
+            doInEDT(new Runnable() {
+                public void run() {
+                    delegate.setValue(currentProgressValue);
+                }
+            });
+        }
+    }
+
+    @Override
+    protected void doSetCustomText(final String title) {
+        checkState(State.IN_TASK, State.IN_SUBTASK);
+        doInEDT(new Runnable() {
+            public void run() {
+                delegate.setCustomText(title);
+            }
+        });
+    }
+
+    @Override
+    protected void doSetTitle(final String title) {
+        checkState(State.IN_TASK, State.IN_SUBTASK);
+        doInEDT(new Runnable() {
+            public void run() {
+                delegate.setTaskTitle(title);
+            }
+        });
+    }
+
+    @Override
+    protected void doSetIntermediate(final boolean value) {
+        doInEDT(new Runnable() {
+            public void run() {
+                delegate.setIndeterminate(value);
+            }
+        });
+    }
+
+    @Override
+    protected void doSetErrorMessage(String message) {
+        // Do nothing
+    }
+}
